gtkmm: Gtk::GestureMultiPress Class Reference

gtkmm 3.22.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::GestureMultiPress Class Reference
Event Controllers and Gestures

Multipress gesture. More...

`#include <gtkmm/gesturemultipress.h>`

Inheritance diagram for Gtk::GestureMultiPress:
[legend]

## Public Member Functions
| GestureMultiPress (GestureMultiPress&& src) noexcept
GestureMultiPress& | operator= (GestureMultiPress&& src) noexcept
| ~GestureMultiPress () noexcept override
GtkGestureMultiPress* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkGestureMultiPress* | gobj () const
| Provides access to the underlying C GObject. More...
GtkGestureMultiPress* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | get_area (Gdk::Rectangle& rect) const
| If an area was set through set_area(), this function will return `true` and fill in rect with the press area. More...
void | set_area (const Gdk::Rectangle& rect)
| If rect is non-`nullptr`, the press area will be checked to be confined within the rectangle, otherwise the button count will be reset so the press is seen as being the first one. More...
void | unset_area ()
| Resets the press area to an unrestricted state. More...
Glib::SignalProxy< void, int, double, double > | signal_pressed ()
Glib::SignalProxy< void, int, double, double > | signal_released ()
Glib::SignalProxy< void > | signal_stopped ()
Public Member Functions inherited from Gtk::GestureSingle
| GestureSingle (GestureSingle&& src) noexcept
GestureSingle& | operator= (GestureSingle&& src) noexcept
| ~GestureSingle () noexcept override
GtkGestureSingle* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkGestureSingle* | gobj () const
| Provides access to the underlying C GObject. More...
GtkGestureSingle* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | get_touch_only () const
| Returns `true` if the gesture is only triggered by touch events. More...
void | set_touch_only (bool touch_only=true)
| If touch_only is `true`, gesture will only handle events of type Gdk::TOUCH_BEGIN, Gdk::TOUCH_UPDATE or Gdk::TOUCH_END. More...
bool | get_exclusive () const
| Gets whether a gesture is exclusive. More...
void | set_exclusive (bool exclusive=true) const
| Sets whether gesture is exclusive. More...
unsigned int | get_button () const
| Returns the button number gesture listens for, or 0 if gesture reacts to any button press. More...
void | set_button (unsigned int button=0)
| Sets the button number gesture listens to. More...
unsigned int | get_current_button () const
| Returns the button number currently interacting with gesture, or 0 if there is none. More...
GdkEventSequence* | get_current_sequence ()
| Returns the event sequence currently interacting with gesture. More...
const GdkEventSequence* | get_current_sequence () const
| Returns the event sequence currently interacting with gesture. More...
Glib::PropertyProxy< bool > | property_touch_only ()
| Whether the gesture handles only touch events. More...
Glib::PropertyProxy_ReadOnly< bool > | property_touch_only () const
| Whether the gesture handles only touch events. More...
Glib::PropertyProxy< bool > | property_exclusive ()
| Whether the gesture is exclusive. More...
Glib::PropertyProxy_ReadOnly< bool > | property_exclusive () const
| Whether the gesture is exclusive. More...
Glib::PropertyProxy< unsigned int > | property_button ()
| Mouse button number to listen to, or 0 to listen for any button. More...
Glib::PropertyProxy_ReadOnly< unsigned int > | property_button () const
| Mouse button number to listen to, or 0 to listen for any button. More...
Public Member Functions inherited from Gtk::Gesture
| Gesture (Gesture&& src) noexcept
Gesture& | operator= (Gesture&& src) noexcept
| ~Gesture () noexcept override
GtkGesture* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkGesture* | gobj () const
| Provides access to the underlying C GObject. More...
GtkGesture* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gdk::Device > | get_device ()
| Returns the master Gdk::Device that is currently operating on gesture, or `nullptr` if the gesture is not being interacted. More...
Glib::RefPtr< const Gdk::Device > | get_device () const
| Returns the master Gdk::Device that is currently operating on gesture, or `nullptr` if the gesture is not being interacted. More...
bool | set_state (EventSequenceState state)
| Sets the state of all sequences that gesture is currently interacting with. More...
EventSequenceState | get_sequence_state (GdkEventSequence*sequence) const
| Returns the sequence state, as seen by gesture. More...
bool | set_sequence_state (GdkEventSequence*sequence, EventSequenceState state)
| Sets the state of sequence in gesture. More...
std::vector< const GdkEventSequence* > | get_sequences () const
| Returns the list of GdkEventSequences currently being interpreted. More...
GdkEventSequence* | get_last_updated_sequence ()
| Returns the Gdk::EventSequence that was last updated on gesture. More...
const GdkEventSequence* | get_last_updated_sequence () const
| Returns the Gdk::EventSequence that was last updated on gesture. More...
bool | handles_sequence (GdkEventSequence*sequence) const
| Returns `true` if gesture is currently handling events corresponding to sequence. More...
const GdkEvent* | get_last_event (GdkEventSequence*sequence) const
| Returns the last event that was processed for sequence. More...
bool | get_point (GdkEventSequence*sequence, double& x, double& y) const
| If sequence is currently being interpreted by gesture, this function returns `true` and fills in x and y with the last coordinates stored for that event sequence. More...
bool | get_bounding_box (Gdk::Rectangle& rect) const
| If there are touch sequences being currently handled by gesture, this function returns `true` and fills in rect with the bounding box containing all active touches. More...
bool | get_bounding_box_center (double& x, double& y) const
| If there are touch sequences being currently handled by gesture, this function returns `true` and fills in x and y with the center of the bounding box containing all active touches. More...
bool | is_active () const
| Returns `true` if the gesture is currently active. More...
bool | is_recognized () const
| Returns `true` if the gesture is currently recognized. More...
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the user-defined window that receives the events handled by gesture. More...
Glib::RefPtr< const Gdk::Window > | get_window () const
| Returns the user-defined window that receives the events handled by gesture. More...
void | set_window (const Glib::RefPtr< Gdk::Window >& window)
| Sets a specific window to receive events about, so gesture will effectively handle only events targeting window, or a child of it. More...
void | unset_window ()
| Undoes the effect of previous calls to set_window(), so the gesture will handle events targeting any Gdk::Window that pertains to Gtk::EventController::get_widget(). More...
void | group (const Glib::RefPtr< Gesture >& group_gesture)
| Adds gesture to the same group than group_gesture. More...
void | ungroup ()
| Separates gesture into an isolated group. More...
std::vector< Glib::RefPtr< Gesture > > | get_group ()
| Returns all gestures in the group of gesture. More...
std::vector< Glib::RefPtr< const Gesture > > | get_group () const
| Returns all gestures in the group of gesture. More...
bool | is_grouped_with (const Glib::RefPtr< Gesture >& other) const
| Returns `true` if both gestures pertain to the same group. More...
Glib::SignalProxy< void, GdkEventSequence*> | signal_begin ()
Glib::SignalProxy< void, GdkEventSequence*> | signal_end ()
Glib::SignalProxy< void, GdkEventSequence*> | signal_update ()
Glib::SignalProxy< void, GdkEventSequence*> | signal_cancel ()
Glib::SignalProxy< void, GdkEventSequence*, EventSequenceState > | signal_sequence_state_changed ()
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_points () const
| The number of touch points that trigger recognition on this gesture,. More...
Glib::PropertyProxy< Glib::RefPtr< Gdk::Window > > | property_window ()
| If non-`nullptr`, the gesture will only listen for events that happen on this Gdk::Window, or a child of it. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Window > > | property_window () const
| If non-`nullptr`, the gesture will only listen for events that happen on this Gdk::Window, or a child of it. More...
Public Member Functions inherited from Gtk::EventController
| EventController (EventController&& src) noexcept
EventController& | operator= (EventController&& src) noexcept
| ~EventController () noexcept override
GtkEventController* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkEventController* | gobj () const
| Provides access to the underlying C GObject. More...
GtkEventController* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Widget* | get_widget ()
| Returns the Gtk::Widget this controller relates to. More...
const Widget* | get_widget () const
| Returns the Gtk::Widget this controller relates to. More...
bool | handle_event (const GdkEvent* event)
| Feeds an events into controller, so it can be interpreted and the controller actions triggered. More...
void | reset ()
| Resets the controller to a clean state. More...
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events. More...
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events. More...
Glib::PropertyProxy_ReadOnly< Widget*> | property_widget () const
| The widget receiving the Gdk::Events that the controller will handle. More...
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< GestureMultiPress > | create (Widget& widget)
| Creates a Gesture that recognizes single and multiple presses. More...
Static Public Member Functions inherited from Gtk::GestureSingle
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Gesture
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| GestureMultiPress ()
| There is no create() method that corresponds to this constructor, because this constructor shall only be used by derived classes. More...
| GestureMultiPress (Widget& widget)
| Constructs a Gesture that recognizes single and multiple presses. More...
Protected Member Functions inherited from Gtk::GestureSingle
| GestureSingle ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Gtk::Gesture
| Gesture ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::GestureMultiPress > | wrap (GtkGestureMultiPress* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::GestureSingle
Glib::RefPtr< Gtk::GestureSingle > | wrap (GtkGestureSingle* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Gesture
Glib::RefPtr< Gtk::Gesture > | wrap (GtkGesture* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Multipress gesture.

This is a Gesture implementation able to recognize multiple clicks on a nearby zone, which can be listened for through signal_pressed(). Whenever time or distance between clicks exceed the GTK+ defaults, signal_stopped() is emitted, and the click counter is reset.

Callers may also restrict the area that is considered valid for a >1 touch/button press through set_area(), so any click happening outside that area is considered to be a first click of its own.

Since gtkmm 3.14:

## Constructor & Destructor Documentation

## § GestureMultiPress() [1/3]

Gtk::GestureMultiPress::GestureMultiPress | ( | GestureMultiPress&& | src | ) |
| noexcept

## § ~GestureMultiPress()

Gtk::GestureMultiPress::~GestureMultiPress | ( |  | ) |
| overridenoexcept

## § GestureMultiPress() [2/3]

Gtk::GestureMultiPress::GestureMultiPress | ( |  | ) |
| protected

There is no create() method that corresponds to this constructor, because this constructor shall only be used by derived classes.

## § GestureMultiPress() [3/3]

Gtk::GestureMultiPress::GestureMultiPress | ( | Widget& | widget | ) |
| explicitprotected

Constructs a Gesture that recognizes single and multiple presses.

## Member Function Documentation

## § create()

static Glib::RefPtr<GestureMultiPress> Gtk::GestureMultiPress::create | ( | Widget& | widget | ) |
| static

Creates a Gesture that recognizes single and multiple presses.

Since gtkmm 3.14:

Parameters

  widget | Widget the gesture relates to.

Returns
  A RefPtr to a new GestureMultiPress.

## § get_area()

bool Gtk::GestureMultiPress::get_area | ( | Gdk::Rectangle& | rect | ) | const

If an area was set through set_area(), this function will return `true` and fill in rect with the press area.

See set_area() for more details on what the press area represents.

Since gtkmm 3.14:

Parameters

  rect | Return location for the press area.

Returns
  `true` if rect was filled with the press area.

## § get_type()

static GType Gtk::GestureMultiPress::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## § gobj() [1/2]

GtkGestureMultiPress* Gtk::GestureMultiPress::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## § gobj() [2/2]

const GtkGestureMultiPress* Gtk::GestureMultiPress::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## § gobj_copy()

GtkGestureMultiPress* Gtk::GestureMultiPress::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## § operator=()

GestureMultiPress& Gtk::GestureMultiPress::operator= | ( | GestureMultiPress&& | src | ) |
| noexcept

## § set_area()

void Gtk::GestureMultiPress::set_area | ( | const Gdk::Rectangle& | rect | ) |

If rect is non-`nullptr`, the press area will be checked to be confined within the rectangle, otherwise the button count will be reset so the press is seen as being the first one.

If rect is #`nullptr`, the area will be reset to an unrestricted state.

Note
  The rectangle is only used to determine whether any non-first click falls within the expected area. This is not akin to an input shape.

Since gtkmm 3.14:

Parameters

  rect | Rectangle to receive coordinates on.

## § signal_pressed()

Glib::SignalProxy< void,int,double,double > Gtk::GestureMultiPress::signal_pressed | ( |  | ) |

Slot Prototype:
  `void on_my_pressed(int n_press, double x, double y)`

This signal is emitted whenever a button or touch press happens.

Since gtkmm 3.14:

Parameters

  n_press | How many touch/button presses happened with this one.
  x | The X coordinate, in widget allocation coordinates.
  y | The Y coordinate, in widget allocation coordinates.

## § signal_released()

Glib::SignalProxy< void,int,double,double > Gtk::GestureMultiPress::signal_released | ( |  | ) |

Slot Prototype:
  `void on_my_released(int n_press, double x, double y)`

This signal is emitted when a button or touch is released. n_press will report the number of press that is paired to this event, note that Gtk::GestureMultiPress::signal_stopped() may have been emitted between the press and its release, n_press will only start over at the next press.

Since gtkmm 3.14:

Parameters

  n_press | Number of press that is paired with this release.
  x | The X coordinate, in widget allocation coordinates.
  y | The Y coordinate, in widget allocation coordinates.

## § signal_stopped()

Glib::SignalProxy< void > Gtk::GestureMultiPress::signal_stopped | ( |  | ) |

Slot Prototype:
  `void on_my_stopped()`

This signal is emitted whenever any time/distance threshold has been exceeded.

Since gtkmm 3.14:

## § unset_area()

void Gtk::GestureMultiPress::unset_area | ( |  | ) |

Resets the press area to an unrestricted state.

Since gtkmm 3.14:

## Friends And Related Function Documentation

## § wrap()

Glib::RefPtr< Gtk::GestureMultiPress > wrap | ( | GtkGestureMultiPress * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.